import { Button, Descriptions,Popconfirm, Row, Col, Form,Modal, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude,extendIgnoreDataRule, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import styles from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from "antd/lib/index";
import FormPage from '../../FormPage'
class PT040ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            BtnAgreeDisplay: 'none',
            BtnChargeAgreeDisplay:'none',
            tmpData: {},
            isModalVisible6: false,
            detailContens:[]
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'PT/PTAnnualMonotorSummary/IdentityUpdate',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }
    onTableBtnChargeAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'PT/PTMonitorAssessment/ChargeAgree',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('已阅成功！');
                    this.setState({ BtnChargeAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }
    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined"&&typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let that=this;
        let json = initFilter(that.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendInclude(json, 'Nav_MonitorAssessment')
        extendInclude(json, 'Nav_Contents')
        extendInclude(json, 'Nav_Department')
        extendInclude(json, 'Nav_User')
        extendIgnoreDataRule(json)
       that.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'PT/MonitorAssessmentDetail/Get',
            onComplete: (ret) => {
                if (ret) {
                    if(that.props.data && that.props.data.loadDataDeal)
                    {
                        that.props.data.loadDataDeal(1);
                    }
                    that.setState({ data: ret });
                    // if (ret.STATUS === 20) {
                    //     that.setState({ BtnAgreeDisplay: 'inline' })
                    // }else{
                    //     that.setState({ BtnAgreeDisplay: 'none' })
                    // }
                    // if(ret.STATUS === 30)
                    // {
                    //     that.setState({ BtnChargeAgreeDisplay: 'inline' })
                    // }
                    // else
                    // {
                    //     that.setState({ BtnChargeAgreeDisplay: 'none' })
                    // }
                    if (that.props.data.tableKey==="2" ||that.props.data.tableKey===undefined) {
                        that.setState({ BtnAgreeDisplay: 'none' })
                    }else{
                        that.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    this.onClickApprove(false);
                    //归档才显示打印和导出按钮
                    // if(ret.PRE_MEETING_STATUS==5){
                    //     this.setState({ isFinished: 'inline' })
                    // }
                }
                else
                { message.error('请先尝试刷新，若仍然加载失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb,"监测与考核得分明细.xlsx")
    }

    onClickApprove=(appVisible)=>{
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true,key:guid(),param:this.props.data.param,appVisible:appVisible,BtnAgreeDisplay:'inline'},
            formCode: "PF123",
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    closModal = () => {
        this.setState({
          isModalVisible: false,
        });
      };
      showModal = (id,quarter) => {
        let temp=this.state.data.Nav_Details.filter(t=>t.ID === id);
        this.setState({
          isModalVisible: true,
          detailContens:temp[0]?.Nav_Contents.filter(t=>t.QUARTER_TYPE === quarter)
        });
      };
    render() {
        const { data } = this.state;
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        // let aaa = Math.random();
        return <div>
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 style={{ textAlign: 'center', margin: '15px' }}>监测与考核得分明细</h1>
                {
                     data ?
                     <div>
                        <Descriptions size="middle" bordered className={styles.description}>
                            <Descriptions.Item label="年度">{data.Nav_MonitorAssessment.YEAR}</Descriptions.Item>
                            <Descriptions.Item label="监测时间">{data.Nav_MonitorAssessment.SET_TIME}</Descriptions.Item>
                            <Descriptions.Item label="监测周期">{enums.PTAssessmentCycleEnums.enums[data.Nav_MonitorAssessment.ASSESSMENT_CYCLE]}</Descriptions.Item>
                            <Descriptions.Item label="考核部门">{data.Nav_Department?.NAME}</Descriptions.Item>
                            <Descriptions.Item label="考核人员">{data.Nav_User?.NAME}</Descriptions.Item>
                        </Descriptions>
                     </div>:null
                }
                 {
                    data ?  <table style={{ width: '100%', textAlign: 'left'}} className={styles.PrintForm1}>
                    <tr>
                    <td width='150px' className={styles.fontBold}>序号</td>
                    <td className={styles.fontBold}>安全生产指标考核项目</td>
                    <td className={styles.fontBold}>分数</td>
                    <td className={styles.fontBold}>考核认定评分办法</td>
                    <td className={styles.fontBold}>考核检查情况</td>
                    <td className={styles.fontBold}>改进措施</td>
                    <td className={styles.fontBold}>得分</td>
                    </tr>
                    {
                                    data?.Nav_Contents && data?.Nav_Contents.map((item,i)=>{
                                        return <tr>
                                            <td>
                                                {i+1}
                                            </td>
                                            <td>
                                                {item.NAME}
                                            </td>
                                            <td>
                                                {item.SCORE}
                                            </td>
                                            <td>
                                                {item.METHOD}
                                            </td>
                                            <td>
                                                {item.CONTENT}
                                            </td>
                                            <td>
                                                {item.MEASURES}
                                            </td>
                                            <td>
                                                {item.RESULT_SCORE}
                                            </td>
                                        </tr>
                                    })
                                }
                    </table>:null 
                }
                <FormPage {...this.state.tmpData} />
            </div>
        </div>
    }

}

export default connect(({ login,app }) => ({ login,app }))(PT040ShowPrint) 